Subject: Re: [PATCH net-next v5 0/2] af_mpls: fix undefined reference to ip6_route_output with CONFIG_IPV6=n

From: roopa <[email-masked]>
Date: Thu, 30 Jul 2015 06:22:55 -0700

On 7/29/15, 10:42 PM, David Miller wrote:
> From: Roopa Prabhu <[email-masked]>
> Date: Tue, 28 Jul 2015 15:27:39 -0700
>
>> v4 - v5: Use ipv6_stub_impl.ipv6_dst_lookup as suggested by Hannes
> I think this might not work.
>
> The ipv6_stub pointer is NULL until the ipv6 module is loaded.
>
> VXLAN can safely call through ipv6_stub->foo() because it _knows_ the
> ipv6 module has been loaded, and will not go away, because it is
> working with an ipv6 socket.
>
> You don't have that set of preconditions here, and thus it is pretty
> easy to generate a scenerio where ipv6_stub will be NULL at your call
> sites.

v4 seems to be a better/safe option in that case. I can resubmit v4 if 
that is acceptable.

>
> This is starting to get really messy, to be honest.  And we've been
> harboring this build failure for several days now.
>
please revert the commit that introduced the IPV6 dependency. I will 
resubmit if needed.
I don't feel good about the build failure either.

Thanks and apologies.

commit 01faef2cebae02685e2bcfc9bbee8416d5ec19fc
Author: Roopa Prabhu <[email-masked]>
Date:   Tue Jul 21 09:16:24 2015 -0700

     mpls: make RTA_OIF optional

     If user did not specify an oif, try and get it from the via address.
     If failed to get device, return with -ENODEV.